# Prints a SAT program in CNF for the 3x3 towers problem.

def pair2int(r,c):
    return 3*(r-1)+c

def attackRestOfRowLeft(r,c):
    lengthOfRest = 3-c
    for k in range(1,lengthOfRest+1):
        print(-pair2int(r,c), -pair2int(r,c+k), 0)

def attackRestOfColumnDown(r,c):
    lengthOfRest = 3-r
    for k in range(1,lengthOfRest+1):
        print(-pair2int(r,c), -pair2int(r+k,c), 0)

def rowNotEmpty(r):
    for c in range(1,4):
        print(pair2int(r,c),end=" ")
    print(0)
        
print("p cnf 9 21")        
for r in range(1,4):
    for c in range(1,4):
        attackRestOfRowLeft(r,c)
        attackRestOfColumnDown(r,c)
for r in range(1,4):
    rowNotEmpty(r)
